'
' Test prog for CBCOLOR.INC - by Borje Hagsten, January 2001.
' Declares
'
#COMPILE EXE
#INCLUDE "WIN32API.INC"
#INCLUDE "CBCOLOR.INC"
'--------------------------------------------------------------------
%ID_LABEL1 = 100
%ID_COLCB1 = 121
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgProc

'
' Main entrance - Create dialog and controls
'
FUNCTION PBMAIN() AS LONG
  LOCAL hDlg AS LONG, hCombo AS LONG, lRes AS LONG

  DIALOG NEW 0, "Color Combo sample", , , 131, 80, %WS_SYSMENU TO hDlg

  hCombo = CreateCBColorList(hDlg, %ID_COLCB1, 4,  4, 120, 120, %TRUE, _
           GetSysColor(%COLOR_WINDOWTEXT), GetSysColor(%COLOR_WINDOWTEXT))
  IF hCombo THEN SendMessage hCombo, %CB_SETCURSEL, 5, 0

  CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Close", 35, 45,  60, 14
  CONTROL ADD LABEL, hDlg, %ID_LABEL1, "",   5, 27, 120, 12, %SS_CENTER

  lRes = SendMessage(hCombo, %CBCOL_GETSELCOLOR, 0, 0)
  CONTROL SET TEXT hDlg, %ID_LABEL1, "Color: &&H" & HEX$(lRes)

  DIALOG SHOW MODAL hDlg, CALL DlgProc
END FUNCTION

'
' Main dialog callback
'
CALLBACK FUNCTION DlgProc
  SELECT CASE CBMSG
     CASE %WM_INITDIALOG
        LOCAL lRes AS LONG

     CASE %WM_DRAWITEM  'must pass this one on to ownerdrawn combo!
        IF CBWPARAM = %ID_COLCB1 THEN
           CONTROL SEND CBHNDL, CBWPARAM, CBMSG, CBWPARAM, CBLPARAM
           FUNCTION = %TRUE : EXIT FUNCTION
        END IF

     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE %IDCANCEL : IF CBCTLMSG = %BN_CLICKED THEN DIALOG END CBHNDL

           CASE %ID_COLCB1
              IF CBCTLMSG = %CBN_SELENDOK THEN 'get selected color
                 lRes = SendMessage(CBLPARAM, %CBCOL_GETSELCOLOR, 0, 0)
                 CONTROL SET TEXT CBHNDL, %ID_LABEL1, "Color: &&H" & HEX$(lRes)
              END IF
        END SELECT

  END SELECT

END FUNCTION
